import java.io.*;
import java.security.*;

public class KnightsAndPawns {
    public String[] placeKnights(String[] board) {
        int H = board.length, W = board[0].length();
        String[] ret = new String[H];
        // initialize with empty board
        char[] row = new char[W];
        for (int j = 0; j < W; ++j)
            row[j] = '.';
        for (int i = 0; i < H; ++i)
            ret[i] = new String(row);
        // find position to place knight
        for (int i = 2; i < H - 2; ++i) 
        for (int j = 2; j < W - 2; ++j) {
            if (board[i].charAt(j) == 'P')
                continue;
            int a = 0;
            for (int di = -2; di <= 2; ++di)
            for (int dj = -2; dj <= 2; ++dj)
                if (Math.abs(di * dj) == 2 && board[i+di].charAt(j+dj) == 'P')
                    a++;
            if (a == 2) {
                row[j] = 'K';
                ret[i] = new String(row);
                return ret;
            }
        }
        return ret;
    }
    // -------8<------- end of solution submitted to the website -------8<-------
    public static void main(String[] args) {
    try {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

        int H = Integer.parseInt(br.readLine());
        String[] board = new String[H];
        for (int i = 0; i < H; ++i) {
            board[i] = br.readLine();
        }

        KnightsAndPawns kap = new KnightsAndPawns();
        String[] ret = kap.placeKnights(board);

        System.out.println(ret.length);
        for (int i = 0; i < ret.length; ++i) {
            System.out.println(ret[i]);
        }
    }
    catch (Exception e) {}
    }
}

